Main Page Namespace List Class Hierarchy Alphabetical List Data Structures File List Namespace Members Data Fields Globals

# ExManagerParticuleSystem Class Reference

`#include <ExManagerParticuleSystem.h>`

Inheritance diagram for ExManagerParticuleSystem:

## Public Methods
ExCAction | InputCommand (ExCCommand Command)
ExCAction | InputAction (ExCAction Action)
void | SetManagerTexture (ExManagerTexture *Texture)
bool | Load (std::string FileName)
void | Init (void)
void | Reset (void)
int | Start (std::string Name)
int | Stop (std::string Name)
int | Pause (std::string Name)
int | Start (ExNihilo::ExId id)
int | Stop (ExNihilo::ExId id)
int | Pause (ExNihilo::ExId id)
int | StartAll (void)
int | StopAll (void)
int | PauseAll (void)
int | GetNumberEnableParticuleSysteme (void)
void | Draw (void)
## Static Public Methods
ExManagerParticuleSystem * | CreateSingleton (void)
## Private Methods
| ExManagerParticuleSystem (void)
| ~ExManagerParticuleSystem (void)
## Private Attributes
ExManagerTexture * | ManagerTexture
## Static Private Attributes
bool | m_flag = false
ExManagerParticuleSystem * | m_instance = NULL

## Constructor & Destructor Documentation

ExManagerParticuleSystem | ( | void |  | ) | `[private]`

| Definition at line 42 of file ExManagerParticuleSystem.cpp. References ExManagerParticuleSystem(), and Guard. Referenced by ExManagerParticuleSystem(), and ~ExManagerParticuleSystem().
    00043 {
    00044 Guard(ExManagerParticuleSystem::ExManagerParticuleSystem(void))
    00045
    00046 UnGuard
    00047 }

~ExManagerParticuleSystem | ( | void |  | ) | `[private]`

| Definition at line 50 of file ExManagerParticuleSystem.cpp. References ExManagerParticuleSystem(), and Guard.
    00051 {
    00052 Guard(ExManagerParticuleSystem::~ExManagerParticuleSystem(void))
    00053 UnGuard
    00054 }

## Member Function Documentation

ExManagerParticuleSystem * CreateSingleton | ( | void |  | ) | `[static]`

| Definition at line 28 of file ExManagerParticuleSystem.cpp. References CreateSingleton(), Guard, m_flag, and m_instance. Referenced by CreateSingleton(), and main().
    00028                                                                        {
    00029 Guard(ExManagerParticuleSystem* ExManagerParticuleSystem::CreateSingleton(void))
    00030         if(!m_flag)
    00031         {
    00032                 m_flag = true; // We are creating the error log now, so set flag to true
    00033                 m_instance = new ExManagerParticuleSystem; // Create the error log
    00034         }else
    00035         {
    00036                 std::cout<<"Error singleton already created"<<std::endl;
    00037         }
    00038         return m_instance;
    00039 UnGuard
    00040 }

void Draw | ( | void |  | ) |

| Reimplemented from ExManagerObject< ExCSystemeParticule >. Definition at line 152 of file ExManagerParticuleSystem.cpp. References Draw(), Guard, ExManagerObject< ExCSystemeParticule >::m_ItMap, and ExManagerObject< ExCSystemeParticule >::m_Map. Referenced by Draw(), and ExManagerOutput::DrawScene().
    00153 {
    00154 Guard(void ExManagerParticuleSystem::Draw(void))
    00155         for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00156         {
    00157                 m_ItMap->second.Draw();
    00158         }
    00159 UnGuard
    00160 }

int GetNumberEnableParticuleSysteme | ( | void |  | ) | `[inline]`

| Definition at line 105 of file ExManagerParticuleSystem.h. References ExManagerObject< ExCSystemeParticule >::m_Map. Referenced by Pause(), PauseAll(), Start(), StartAll(), Stop(), and StopAll().
    00106 {return m_Map->size();}

void Init | ( | void |  | ) | `[virtual]`

| Reimplemented from ExManagerObject< ExCSystemeParticule >. Definition at line 56 of file ExManagerParticuleSystem.cpp. References Guard, ExManagerObject::Init(), and ExManagerModel::Init(). Referenced by InitManager().
    00057 {
    00058 Guard(void ExManagerModel::Init(void))
    00059         ExManagerObject<ExCSystemeParticule>::Init();
    00060 UnGuard
    00061 }

ExCAction InputAction | ( | ExCAction | Action | ) | `[virtual]`

| Reimplemented from ExManager. Definition at line 193 of file ExManagerParticuleSystem.cpp. References ExManager::Consol, ExManagerObject< ExCSystemeParticule >::GetObject(), Guard, InputAction(), ExManagerObject< ExCSystemeParticule >::List(), Load(), ExCAction::m_Action, ExCAction::m_NextAction, ExCAction::m_Param, ExCSystemeParticule::Pause(), PauseAll(), ExCSystemeParticule::Start(), StartAll(), ExCSystemeParticule::Stop(), and StopAll(). Referenced by InputAction(), and ExManagerCommand::ProcesExCAction().
    00194 {
    00195 Guard(ExCAction ExManagerParticuleSystem::InputAction(ExCAction Action))
    00196         switch(Action.m_Action)
    00197         {
    00198         case LOAD_PARTICULESYSTEME:Load(Action.m_Param);break;
    00199     case STAR_PARTICULESYSTEME:GetObject(Action.m_Param)->Start();break;
    00200         case STOP_PARTICULESYSTEME:GetObject(Action.m_Param)->Stop();break;
    00201         case PAUSE_PARTICULESYSTEME:GetObject(Action.m_Param)->Pause();break;
    00202         case STAR_ALL_PARTICULESYSTEME:StartAll();break;
    00203         case STOP_ALL_PARTICULESYSTEME:StopAll();break;
    00204         case PAUSE_ALL_PARTICULESYSTEME:PauseAll();break;
    00205         case LIST_PARTICULESYSTEME:List();break;
    00206
    00207         default:
    00208                 *Consol<<"Can not file action in PARTICULESYSTEME_ACTION_MAP"<<std::endl;
    00209                 break;
    00210         }
    00211         if(Action.m_NextAction){return *Action.m_NextAction;}
    00212         else{return NOTHING;}
    00213 UnGuard
    00214 }

ExCAction InputCommand | ( | ExCCommand | Command | ) | `[virtual]`

| Reimplemented from ExManager. Definition at line 186 of file ExManagerParticuleSystem.cpp. References Guard, and InputCommand(). Referenced by InputCommand().
    00187 {
    00188 Guard(ExCAction ExManagerParticuleSystem::InputCommand(ExCCommand Command))
    00189         return NOTHING;
    00190 UnGuard
    00191 }

bool Load | ( | std::string | FileName | ) |

| Reimplemented from ExManagerObject< ExCSystemeParticule >. Definition at line 68 of file ExManagerParticuleSystem.cpp. References ExManagerObject::Add(), ExManager::Consol, ExCSystemeParticule::Consol, Guard, ExCSystemeParticule::Load(), Load(), ManagerTexture, and ExCSystemeParticule::SetManagerTexture(). Referenced by InputAction(), ExManagerCommand::InputAction(), and Load().
    00069 {
    00070 Guard(bool ExManagerParticuleSystem::Load(std::string FileName))
    00071     FileName="../Data/ParticuleSystem/"+FileName;
    00072         try
    00073         {
    00074                 ExCSystemeParticule     systeme;
    00075                 systeme.Consol=Consol;
    00076                 systeme.SetManagerTexture(ManagerTexture);
    00077                 systeme.Load(FileName);
    00078                 return ExManagerObject<ExCSystemeParticule>::Add(systeme);
    00079         }
    00080         catch(ExCExpFileNotFound)
    00081         {
    00082                 *Consol<<"ExManagerParticuleSystem::ExCeption =>"<<FileName<<" File not found"<<std::endl;
    00083                 return false;
    00084         }
    00085         catch(ExCExpFileReadError)
    00086         {
    00087                 *Consol<<"ExManagerParticuleSystem::ExCeption =>"<<FileName<<" Read file error"<<std::endl;
    00088                 return false;
    00089         }
    00090         catch(...)
    00091         {
    00092                 *Consol<<"ExManagerParticuleSystem::ExCeption =>"<<FileName<<" Unknow exception"<<std::endl;
    00093                 return false;
    00094         }
    00095 UnGuard
    00096 }

int Pause | ( | ExNihilo::ExId | id | ) |

int Pause | ( | std::string | Name | ) |

| Definition at line 127 of file ExManagerParticuleSystem.cpp. References GetNumberEnableParticuleSysteme(), Guard, and Pause(). Referenced by Pause().
    00128 {
    00129 Guard(int ExManagerParticuleSystem::Pause(std::string Name))
    00130         /*for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00131         {
    00132                 if(strcmp(m_ItMap->GetParticuleSystemeName(),param.data())==0)
    00133                 {
    00134                         m_ItMap->Pause();
    00135                 }
    00136         }*/
    00137         return GetNumberEnableParticuleSysteme();
    00138 UnGuard
    00139 }

int PauseAll | ( | void |  | ) |

| Definition at line 173 of file ExManagerParticuleSystem.cpp. References GetNumberEnableParticuleSysteme(), Guard, ExManagerObject< ExCSystemeParticule >::m_ItMap, ExManagerObject< ExCSystemeParticule >::m_Map, and PauseAll(). Referenced by InputAction(), and PauseAll().
    00174 {
    00175 Guard(int ExManagerParticuleSystem::PauseAll(void))
    00176         for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00177         {
    00178                 m_ItMap->second.Pause();
    00179         }
    00180         return GetNumberEnableParticuleSysteme();
    00181 UnGuard
    00182 }

void Reset | ( | void |  | ) | `[virtual]`

| Reimplemented from ExManagerObject< ExCSystemeParticule >. Definition at line 63 of file ExManagerParticuleSystem.cpp. References ExManagerObject::Reset(). Referenced by ExManagerCommand::ProcesExCAction().
    00064 {
    00065         ExManagerObject<ExCSystemeParticule>::Reset();
    00066 }

void SetManagerTexture | ( | ExManagerTexture * | Texture | ) | `[inline]`

| Definition at line 87 of file ExManagerParticuleSystem.h. References ManagerTexture. Referenced by SetManagerLink().
    00088 {ManagerTexture = Texture;}

int Start | ( | ExNihilo::ExId | id | ) |

int Start | ( | std::string | Name | ) |

| Definition at line 98 of file ExManagerParticuleSystem.cpp. References GetNumberEnableParticuleSysteme(), Guard, and Start(). Referenced by Start().
    00099 {
    00100 Guard(int ExManagerParticuleSystem::Start(std::string Name))
    00101         /*for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00102         {
    00103                 if(strcmp(m_ItMap->GetParticuleSystemeName(),param.data())==0)
    00104                 {
    00105                         m_ItMap->Start();
    00106                 }
    00107         }
    00108          */
    00109         return GetNumberEnableParticuleSysteme();
    00110 UnGuard
    00111 }

int StartAll | ( | void |  | ) |

| Definition at line 141 of file ExManagerParticuleSystem.cpp. References GetNumberEnableParticuleSysteme(), Guard, ExManagerObject< ExCSystemeParticule >::m_ItMap, ExManagerObject< ExCSystemeParticule >::m_Map, and StartAll(). Referenced by InputAction(), and StartAll().
    00142 {
    00143 Guard(int ExManagerParticuleSystem::StartAll(void))
    00144         for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00145         {
    00146                 m_ItMap->second.Start();
    00147         }
    00148         return GetNumberEnableParticuleSysteme();
    00149 UnGuard
    00150 }

int Stop | ( | ExNihilo::ExId | id | ) |

int Stop | ( | std::string | Name | ) |

| Definition at line 113 of file ExManagerParticuleSystem.cpp. References GetNumberEnableParticuleSysteme(), Guard, and Stop(). Referenced by Stop().
    00114 {
    00115 Guard(int ExManagerParticuleSystem::Stop(std::string Name))
    00116         /*for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00117         {
    00118                 if(strcmp(m_ItMap->GetParticuleSystemeName(),param.data())==0)
    00119                 {
    00120                         m_ItMap->Stop();
    00121                 }
    00122         }*/
    00123         return GetNumberEnableParticuleSysteme();
    00124 UnGuard
    00125 }

int StopAll | ( | void |  | ) |

| Definition at line 162 of file ExManagerParticuleSystem.cpp. References GetNumberEnableParticuleSysteme(), Guard, ExManagerObject< ExCSystemeParticule >::m_ItMap, ExManagerObject< ExCSystemeParticule >::m_Map, and StopAll(). Referenced by InputAction(), and StopAll().
    00163 {
    00164 Guard(int ExManagerParticuleSystem::StopAll(void))
    00165         for(m_ItMap=m_Map->begin();m_ItMap!=m_Map->end();m_ItMap++)
    00166         {
    00167                 m_ItMap->second.Stop();
    00168         }
    00169         return GetNumberEnableParticuleSysteme();
    00170 UnGuard
    00171 }

## Field Documentation

bool m_flag = false`[static, private]`

| Definition at line 25 of file ExManagerParticuleSystem.cpp. Referenced by CreateSingleton().

ExManagerParticuleSystem * m_instance = NULL`[static, private]`

| Definition at line 26 of file ExManagerParticuleSystem.cpp. Referenced by CreateSingleton().

ExManagerTexture* ManagerTexture`[private]`

| Definition at line 70 of file ExManagerParticuleSystem.h. Referenced by Load().

The documentation for this class was generated from the following files:

- ExManagerParticuleSystem.h
- ExManagerParticuleSystem.cpp